<?php
/*
 * ind_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2006  Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';
require_once 'exercises/components/Component.class.php';

/**
 * ind_exercise.php
 *
 * Die "Individuelle Aufgabe" lt sich frei aus verschiedenen Teilen und Modulen (wie
 * Titelzeile, Aufgabentext, Kommentarfeld, Grafik, Eingabefeld, Multiple-Choice-Modul,
 * ...) zusammensetzen.
 *
 * @author Martin Schroeder (marschro@uos.de)
 * @copyright Zentrum virtUOS
 */
class ind_exercise extends Exercise
{
//      var $g_ExerciseName;
//      var $g_ExerciseDescription;
//      var     $g_Action;
//      var     $g_OpenObject;
//      
        
        
        /* constructor */
        function ind_exercise()
        {
                /*$this->g_ExerciseName = _("Individuelle Aufgabe");
                $this->g_ExerciseDescription = _("frei gestaltbare Aufgabe");
                $this->g_Action = getExternalParam("action");
                $this->g_OpenObject = 'openobject_'. strtolower(getExternalParam('action'));*/
        }
        
        
        
        
        
        
        
        function printFormToGenerateExercise
                ( $p_exercise_sheet_id
                , $p_exercise_position
                , $p_exercise_maximum_score
                , $p_exercise_id = ""
                , $p_exerciseXML = ""
                )
        {
                $m_template = new ViPSTemplate_php("exercise_generate");
/*              $m_tabltempl = new ViPSTemplate_php("zebra_table");
                $ar = array
                        ( "showHeader" => 1
                        , "header" => array(array(1, "right"), array(2, "center", 2))
                        , "content" => array("abc", "def", "ghi", array("123", "456"))
                        );
                print_r($ar);
                $m_tabltempl-> set_attribute("t_data", $ar);
                echo $m_tabltempl->render();
*/              
                // hidden entries
                $m_template->set_attribute("t_hidden_view", "openobject_".strtolower($this->g_Action));
                $m_template->set_attribute("t_hidden_action", $this->g_Action);
                $m_template->set_attribute("t_hidden_exercise_type", get_class($this));
                $m_template->set_attribute("t_hidden_exercise_id", $p_exercise_id);
                $m_template->set_attribute("t_hidden_exercise_sheet_id", $p_exercise_sheet_id);
                $m_template->set_attribute("t_hidden_exercise_position", $p_exercise_position);
                $m_template->set_attribute("t_hidden_exercise_maximum_score", $p_exercise_maximum_score);
                
                $m_template->set_attribute("t_header", $this->g_ExerciseName);
                
#               $m_template->set_attribute("t_show_title", 1);
                
#               $m_template->set_attribute("t_show_text", 1);
#               $m_template->set_attribute("t_text_rows", 3);
                
                $m_template->set_attribute("t_add_button_source", makeButton("hinzufuegen", "src"));
                $m_template->set_attribute("t_ok_button_source", makeButton("ok", "src"));
                
                $tmpArray = $this->getTagsFromXML($p_exerciseXML, "Name");
                $m_exercise_name = $tmpArray[0];
                
                $m_modules = array
                        ( array(_("Titel"), "Name", "name", $m_exercise_name)
#                       , array(_("Aufgabentext"), "textarea6", "exercise_text", "")
#                       , array("submit button", makeButton("ok", "src"))
                        );
                $i = 0;
                $parser = xml_parser_create();
                xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, FALSE);
                xml_parse_into_struct($parser, $p_exerciseXML, $vals);
                xml_parser_free($parser);
                print_r($vals);
                foreach ($vals as $m_value)
                {
                        if (/*$m_value["type"] == "complete" && */$m_value["tag"] != "Name" && $m_value["level"] > 1)    // skip opening and closing tags and <Name>-Tag (handled above as it is obligatory for each exercise!)
                        {
                                if ($m_value["attributes"]["Title"] == "") $m_value["attributes"]["Title"] = "%title%";
                                array_push($m_modules, array
                                        ( _($m_value["attributes"]["Title"])
                                        , $m_value["tag"]
                                        , $i++
                                        , $m_value["value"]
                                        ));
                        }
                }
#               print_r($m_modules);
                $m_template->set_attribute("t_modules", $m_modules);
                
                
                
                // RIGHT COLUMN //
                $m_edit_module = getExternalParam("module_id");
                
                if (!$m_edit_module)
                {
                        $m_template->set_attribute("t_right_column_header", _("Module hinzuf&uuml;gen"));
                        $m_lecturer_module_list = array
                                ( array("--- "._("Modul hinzuf&uuml;gen")."... ---", "NULL")
                                , array(_("Aufgabentext"), "Paragraph")
                                , array(_("Grafik"), "PictureURL")
                                );
                        $m_student_module_list = array
                                ( array("--- "._("Modul hinzuf&uuml;gen")."... ---", "NULL")
                                , array(_("Eingabefeld f&uuml;r einzeiligen Text"), "input field")
                                , array(_("Texteingabefeld, klein"), "textarea6")
                                , array(_("Texteingabefeld, gro&szlig;"), "textarea15")
                                , array(_("Texteingabefeld, sehr gro&szlig;"), "textarea30")
                                , array(_("Multiple-Choice-Tabelle"), "MultipleChoice")
                                , array(_("Single-Choice-Tabelle"), "sc table")
                                , array(_("Eingabefeld f&uuml;r Prolog-Code"), "prolog")
                                , array(_("Kommentarfeld"), "CommentField")
                                );
                        $m_template->set_attribute("t_lecturer_module_list", $m_lecturer_module_list);
                        $m_template->set_attribute("t_student_module_list", $m_student_module_list);
                        
                        $m_template->set_attribute("t_add_lecturer_module", _("Nur vom Dozenten ver&auml;nderbare Module"));
                        $m_template->set_attribute("t_add_student_module", _("Eingabem&ouml;glichkeiten f&uuml;r Studenten"));
                }
                
                else  // if $m_edit_module...
                {
                        $m_template->set_attribute("t_right_column_header", _("Modul bearbeiten"));
                        #$m_template->set_attribute("t_right_column_content"
                }
                
#               echo $m_template->render();
                
                
                
                
                ###################################################################
                
                ###################################################################
                
                ###################################################################
                
                ###################################################################
                
                ###################################################################
                
                
                
                global $g_format;
                $m_table = new Table();
                $m_output = $m_table->open($g_format["table"]);
                
                // open form for saving changes in a component (spanning all components!)
                $m_output .= "<form method=\"post\">\n"
                        .$this->getLecturerHiddenFormularEntries
                                ( get_class($this)
                                , $p_exercise_id
                                , $p_exercise_sheet_id
                                , $p_exercise_position
                                , $p_exercise_maximum_score
                                )
                        .(($unfold = getExternalParam("unfold")) != null
                                ? "<input type=\"hidden\" name=\"unfold\" value=\"$unfold\">"
                                : "")
                        ;
                
                // process each component
                $i = 0;
                foreach ($vals as $m_value)
                {
                        if ($m_value["level"] < 2) continue;
                        
                        // create new component of type "<Tag>"
                        require_once 'exercises/components/'.$m_value["tag"].".class.php";
                        $m_comp = new $m_value["tag"];
                        $m_comp->initComponent($m_value);
                        
                        // "header" showing the component type ("Title", "Multiple Choice component", ...)
                        $m_output .= $m_table->openRow($g_format["row"]);
                        $m_output .= $m_table->cell("<a href=\"".vips_url()
                                                ."?view=openobject_vips_uebungsblatt"
                                                ."&action=vips_uebungsblatt"
                                                ."&subaction=edit_exercise"
                                                ."&exercise_id=$p_exercise_id"
                                                ."&exercise_position=$p_exercise_position"
                                                ."&exercise_sheet_id=$p_exercise_sheet_id"
                                                .(getExternalParam("unfold") == "$i"
                                                        ? ""
                                                        : "&unfold=$i")
                                                ."\" "
                                                .(getExternalParam("unfold") == "$i"
                                                        ? tooltip(_("Bearbeiten abbrechen"))
                                                        : tooltip(_("Komponente bearbeiten")))
                                                .">"
                                        .(getExternalParam("unfold") == "$i"
                                                ? "<img src=\"pictures/pfeildunkelgraurunt.gif\" border=\"0\">"
                                                : "<img src=\"pictures/pfeilgrau.gif\" border=\"0\">")
                                        ."&nbsp;"
                                        ."<font style=\"font-style: italic;\">".$m_comp->g_componentType.": </font>".$m_comp->g_componentTitle
                                        ."</a>"
                                , $g_format["cell"]);
                        #$m_output .= $m_table->cell($m_value["attributes"]["title"], $g_format["cell"]);
                        $m_output .= $m_table->closeRow();
                        
                        
                        
                        // if component is unfolded, present to the lecturer the component's
                        // generateLecturerComponent() function
                        if (getExternalParam("unfold") == "$i")
                        {
                                $m_output .= $m_table->openRow($g_format["row"]);
                                $m_output .= $m_table->cell($m_comp->generateComponentEdit()
                                        , $g_format["cell"]);
                                $m_output .= $m_table->closeRow();
                        }
                        
                        $i++;
                }
                
                // close form tag (which spans all components)
                $m_output .= "</form>\n";
                
                
                
                
                
                // form for adding components  //
                
                $m_output .= $m_table->openRow($g_format["row"]);
                $m_selectBox = "<select name=\"add_component\">";
                for ($i = 0; $i < 6;)
                {
                        $i++;
                        $m_selectBox .= "<option value=\"$i\">$i</option>";
                }
                $m_selectBox .= "</select>";
                $m_output .= $m_table->cell($m_selectBox, $g_format["cell"]);
                $m_output .= $m_table->cell("<form action=\"vips.php\" method=\"post\">"
                                .$this->getLecturerHiddenFormularEntries
                                        ( get_class($this)
                                        , $p_exercise_id
                                        , $p_exercise_sheet_id
                                        , $p_exercise_position
                                        , $p_exercise_maximum_score)
                                .(($unfold = getExternalParam("unfold"))
                                        ? "<input type=\"hidden\" name=\"unfold\" value=\"$unfold\">"
                                        : "")
                                ."<input type=\"image\" ".makeButton("hinzufuegen", "src").">"
                                ."</form>"
                        , $g_format["cell"]);
                $m_output .= $m_table->closeRow();
                $m_output .= $m_table->close();
                echo $m_output;
        }
        
        
        
        
        
        
        
        
        /**
         * Generate the description af an exercise in an XML-String.
         *
         * The individual exercise must be able to handle the following tags:
         * <Hint>
         * <PictureURL>
         * <Provides>
         * <Depends>
         * <OptionalDepends>
         * <AnswerDistance>
         * <Question>:<Paragraph>
         * <Answer>
         * <CommentField>
         * <Solution> (for TextBox type)
         * 
         * @return XML the XML-String describing the exercise in terms of its
         * name, questions, wrong and correct solutions etc.
         */
        
        function getExerciseConstruct()
        {
                echo $m_componentPosition = getExternalParam("componentPosition");
                $m_domDoc = domxml_new_doc(domxml_version());
                
                // parent
                $m_testItem = $m_domDoc->create_element("TestItem");
                $m_testItem->set_attribute("ID", getExternalParam("exercise_type"));
                $m_testItem->set_attribute("Language", "de");
                $m_domDoc->append_child($m_testItem);
                
                // 
                $m_title = $m_domDoc->create_element("Name");
                $m_title->append_child($m_domDoc->create_text_node("Individuelle Aufgabe"));
                
                $m_testItem->append_child($m_title);
                
#               print_r(domxml_xmltree($m_testItem));
#               print_r($m_domDoc->dump_mem());
                echo "<pre>";
                echo htmlentities($m_domDoc->dump_mem());
                echo "</pre>";
                return '<TestItem><Name>Individuelle Aufgabe</Name><Text title="Aufgabenstellung zu Agenten" position="1">Welcher dieser Agenten ist depressiv?</Text></TestItem>';
        }
        
        
        
        
        
        
        
        /** */
        function add_module($p_XML, $p_type)
        {
                $xml_return_value = substr_replace
                        ( $p_XML
                        , "<$p_type></$p_type></TestItem>"
                        , -11
                        );
                
                return $xml_return_value;
        }
        
        
        
        
        
        
        
        /** */
        function create_module_XML($p_type)
        {
                if ($p_type == "MultipleChoice")
                {
                        $m_XML = "<MultipleChoice Title=\""._("Multiple Choice-Modul")."\" Type=\""._("Multiple Choice-Aufgabe")."\" Status=\"incomplete\"></MultipleChoice>";
                }
                
                return $m_XML;
        }
        
        
        
        
        
        
        
        /** */
        function edit_module($p_module_id)
        {
                
        }
}
?>
