<?php
/*
 * rnd_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * "Random" exercise. Randomly chooses an exercise from a specified list of
 * "subexercises".
 *
 * @author Martin Schr&ouml;der
 * @copyright virtUOS, 2004-2006
 */
class rnd_exercise extends Exercise
{
    
//      var $g_ExerciseName        = "Zufallsfrage";
//      var $g_ExerciseDescription = "zuf&auml;llig ausgew&auml;hlte Frage";
    
    
    #############################
    #                           #
    #   C O N S T R U C T O R   #
    #                           #
    #############################
    
    /**************
    * constructor *
    **************/
    function rnd_exercise()
    {
        $this->g_Action         = getExternalParam('action');
        $this->g_OpenObject = 'openobject_'. strtolower(getExternalParam('action'));
    }
    
    
    
    
    
    #######################
    #                     #
    #   E V A L U A T E   #
    #                     #
    #######################
    
    /**
     * Link to subexercise's evaluate function that the user gets presented.
     */
    function evaluate($p_exercise_XML, $p_solution_id, $p_user_id, $p_points)
    {
        global $auth, $vips_db;
        
        // fetch user id
        $user_id = ($extparam = getExternalParam("user_id")) ? $extparam : $auth->auth["uid"];
        
        // the id of the random exercise is bergeben as POST variable in solutions->correct_uncorrected_solutions()
        $exercise_id = getExternalParam("exercise_id");
        
        // choose one of the subexercises
        $subexercise_id = $this->choose_subexercise($p_exercise_XML, $user_id, $exercise_id);
        
        $query = "SELECT Aufgabe, URI
            FROM vips_aufgabe
            WHERE ID = '$subexercise_id'
            ";
        $result = $vips_db->executeQuery($query);
        $result->next();
        $subexercise_XML = $result->get("Aufgabe");
        $subexercise_type = $result->get("URI");
        
        require_once "exercises/$subexercise_type.php";
        $o_class = new $subexercise_type;
        $o_class->setEvalMode($this->getEvalMode());
        
        if ($subexercise_type == "pl_exercise")
        {
            return $o_class->evaluate($subexercise_XML, $p_solution_id, $p_user_id, $p_points);
        }
        else
        {
            return $o_class->evaluate($subexercise_XML, $p_solution_id);
        }
    }
    
    
    
    
    
    #######################################################
    #                                                     #
    #   P R I N T   F O R M   T O   G E T   A N S W E R   #
    #                                                     #
    #######################################################
    
    /**
     * Prints a form in order to get answer from student.
     */
    function printFormToGetAnswer
        ( $p_exercise_id
        , $p_exercise_sheet_id
        , $p_exerciseXML
        , $p_exercise_name
        , $p_solutionXML          = ""
        , $p_exercise_solution_id = ""
        , $p_student_comment      = ""
        , $p_assess_solution      = FALSE
        )
    {
        global $auth;
        
        $m_user_id =
            ($extparam = getExternalParam("user_id"))
            ? $extparam
            : $auth->auth["uid"]
            ;
        
        $m_subexercise_array = $this->chooseSubexercise($m_user_id, $p_exercise_id);
        
        if ($m_subexercise_array)
        {
            $m_this_exercise_id        = getExternalParam("rnd_exercise");
            #$m_chosen_subexercise_id   = $m_subexercise_array["id"];
            $m_chosen_subexercise_type = $m_subexercise_array["type"];
            $m_chosen_subexercise_xml  = $m_subexercise_array["xml"];
            $m_chosen_subexercise_name = $m_subexercise_array["name"];
            
            // calls the chosen subexercise's printFormToGetAnswer method
            $m_0class = new $m_chosen_subexercise_type;
            echo $m_0class->printFormToGetAnswer
                ( $m_this_exercise_id         // Use id of random exercise...
                , $p_exercise_sheet_id
                , $m_chosen_subexercise_xml   // ... but XML of chosen subexercise!!!
                , $p_exercise_name . ": " . $m_chosen_subexercise_name
                , $p_solutionXML
                , $p_exercise_solution_id
                , $p_student_comment
                , $p_assess_solution
            );
        }
    }
    
    
    
    
    
    function getSolution($exercise_id, $solution_id)
    {
    }
    
    
    
    
    
    function genSolution($p_exercise_id, $p_number_of_answers)
    {
        global $auth;
        
        // fetch user id
        $m_user_id = ($extparam = getExternalParam("user_id")) ? $extparam : $auth->auth["uid"];
        
        // choose one of the subexercises
        $m_subexercise_array = $this->chooseSubexercise($m_user_id, $p_exercise_id);
        
        echo $m_chosen_subexercise_id = $m_subexercise_array["id"];
        echo $m_chosen_subexercise_type = $m_subexercise_array["type"];
        $m_0class = new $m_chosen_subexercise_type;
        return $m_0class->genSolution($m_chosen_subexercise_id, $p_number_of_answers);
    }
    
    
    
    
    
    function setSolution($exercise_id, $solution_id)
    {
    }
    
    function getStatistic($exercise_id, $course_id)
    {
    }
    
    
    
    /////////////////////////////////////////////////////
    //                                                 //
    //   G E T   E X E R C I S E   C O N S T R U C T   //
    //                                                 //
    /////////////////////////////////////////////////////
    
    /**
     * This function computes the XML value to represent the exercise.
     */
    function getExerciseConstruct()
    {
        $exercise_language = "de";
        $exercise_type     = getExternalParam("exercise_type");
        $exercise_name     = getExternalParam("exercise_name");
        $exercise_question = getExternalParam("exercise_question");
        $exercise_hint     = getExternalParam("exercise_hint");
        $exercise_comment  = getExternalParam("exercise_comment");
#               $exercise_pic_url  = getExternalParam("exercise_pic_url");  //??
#               $provides          = getExternalParam("provides");  //??
#               $depends           = getExternalParam("depends"); //??
#               $optional_depends  = getExternalParam("optional_depends"); //??
#               $number_of_answers = getExternalParam("number_of_answers");
        
        #$mode                = getExternalParam("mode");
        $subexercises_number = getExternalParam("subexercises_number");
        $stored_subexercises = getExternalParam("stored_subexercises");
        #$subexercises_to_add = $mode == "add"
        #       ? getExternalParam("subexercises_to_add")
        #       : 0
        #       ;
        
        
        
        // Fill an array with all subexercise ids, if id is not to be deleted!
        $array_index = 0;
        for ($i = 0; $i < $subexercises_number/* + $subexercises_to_add*/; $i++)
        {
            $id          = getExternalParam("sub_exercise-$i"); // may be ""
            $delete_flag = getExternalParam("collect-$i");
            
            if (!$delete_flag || $mode != "delete")
            {
                $subexercise_array[$array_index++] = $id;
            }
        }
        
        
        
        /////////////////////////////
        // Construct return value. //
        /////////////////////////////
        $xml_return_value = "<TestItem ID=\"".$exercise_type."\" "
            ."Type=\"".$this->g_ExerciseName."\" "
            ."Language=\"".$exercise_language."\">"
            ."<Name>".htmlspecialchars($exercise_name)."</Name>"
            .'<CommentField Visible="'.$exercise_comment.'"></CommentField>';
            ;
        
        // every subexercise is put into XML //
        foreach ($stored_subexercises as $sub_id)
        {
            $xml_return_value .= "<SubExercise ID=\"".$sub_id."\"/>";
        }
        
        // add new subexercise //
        if (getExternalParam("add") || getExternalParam("add_x") != '')
        {
            $exercise_to_add = getExternalParam("existing_exercises");  // from dropdown menu
            
            if ($exercise_to_add != "NULL")
            {
                $xml_return_value .= "<SubExercise ID=\"".$exercise_to_add."\"/>";
            }
        }
        
        
        $xml_return_value .= "</TestItem>";
        
        return $xml_return_value;
    }
    
    
    
    
    
    ###################################################
    #                                                 #
    #   A P P E N D   N E W   S U B E X E R C I S E   #
    #                                                 #
    ###################################################
    
    /**
     * Appends a new subexercise to a given random exercise.
     *
     * @param $p_XML The XML representation of the random exercise as it is constructed by
     *               <cc>getExerciseConstruct</cc>.
     * @param $p_ID A new ID which will be inserted to the end of the given XML string.
     *
     * @returns The new XML string with the new ID appended.
     */
    function appendNewSubexercise($p_XML, $p_ID)
    {
        // Overwrite the end tag ("</TestItem>", 11 characters long!) with the new
        // <SubExercise> tag plus a new "</TestItem>". Result: the new <SubExercise> tag has
        // been inserted.
        $xml_return_value = substr_replace
            ( $p_XML
            , "<SubExercise ID=\"$p_ID\"/></TestItem>"
            , -11
            );
        
        return $xml_return_value;
    }
    
    
    
    
    
    
    /**
     * Deletes a subexercise from the exercise XML.
     */
    function delete_subexercise($p_xml, $p_id)
    {
        return str_replace("<SubExercise ID=\"$p_id\"/>", "", $p_xml);
    }
    
    
    
    
    
    ###########################################
    #                                         #
    #   C H O O S E   S U B E X E R C I S E   #
    #                                         #
    ###########################################
    
    /**
     * Chooses a subexercise dependent on the user id.
     *
     * @param $p_user_id The user id as hexadecimal md5-hash.
     * @param $p_rnd_exercise_id The random exercise's id.
     * @return The id of the chosen subexercise.
     */
    function choose_subexercise($p_xml, $p_user_id, $p_rnd_exercise_id)
    {
        // Initializing randomizer with specific data (user and exercise dependend) determines
        // the exercise the user is given!
        $randomizer_start = crc32($p_user_id.$p_rnd_exercise_id);
        mt_srand($randomizer_start);
        
        // chooses a subexercise from the given set of subexercises stored in
        // this random exercise
        $subexercise_ids =
            $this->getAttributesFromXML  // in exercise.php
                ( $p_xml
                , "SubExercise"
                , "ID"
                );
        $subexercises_number = count($subexercise_ids);
        
        if ($subexercises_number > 0)
        {
            $chosen_index          = mt_rand(0, $subexercises_number - 1);
            $chosen_subexercise_id = $subexercise_ids[$chosen_index];
            return $chosen_subexercise_id;
        }
        
        return false;
    }
}
?>
