<?php
/*
 * sc_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    XXX
 * @copyright XXX
 * @abstract
 * @TODO Fix dozent view.
 */
class sc_exercise extends Exercise {
    
//       var $g_numberOfAnswers;
//       var $g_ExerciseName = "Single Choice";
//       var $g_ExerciseDescription = "DescriptionExerciseSC";
    var $g_maxPoints;
    
    
    
    function sc_exercise() {
//               //$this->g_ExerciseName                = "Multiple Choice";
//               //$this->g_ExerciseDescription         = "DescriptionExerciseMC";
//               $this->g_numberOfAnswers               = 5;
//               $this->g_Action                                        = getExternalParam('action');
//               $this->g_OpenObject                            = 'openobject_' . strtolower($this->g_Action);
    }
    
    
    
    /**************************************************************************/
    /*
    /* Evaluates the solution
    /*
    /**************************************************************************/
    
    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */
    
    function evaluate($exercise, $solution) {
        // get the xml representation
        $dom_xml = $this->getDomXML($exercise);
        $answers = $dom_xml->get_elements_by_tagname("Answer");
        $mc_auswertung = $this->getEvalMode();
        $punkte = 0;
        
        $answer_array = array();
        $correct_array = array();
        
        foreach ($answers as $key => $node)
        {
            $group = $node->get_attribute("group");
            if ($group == '') $group = 0;
            
            $answer_array[$group][] = html_ready(utf8_decode($node->get_content()));
            if ($node->get_attribute("Correct") == '1')
                $correct_array[$group] = count($answer_array[$group]) - 1;
        }
        
        $student_array = $this->getTagsFromXML($solution, "answer");
        
        for ($group = 0; $group < count($correct_array); ++$group) {
            if ($student_array[$group] == $correct_array[$group])
                ++$punkte;
            else if ($mc_auswertung == 1 || $mc_auswertung == 2)
                --$punkte;      // abzug bei falscher antwort
        }
        
        if ($punkte < 0 && $mc_auswertung != 2)
            $punkte = 0;
        
        $m_prozent = $punkte / count($correct_array) * 100;
        $safe = 1;
        
        $m_return[1] = $m_prozent;
        $m_return[2] = $safe;
        $m_return[5] = $punkte;
        return $m_return;
    }
    
    
    
    /**
     * Generates generates an XML-String containing the solution of the
     * student.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @param int $exercise_id the id of the exercise the solution related to.
     * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
     * @return XML the XML-String containing the solutions of the student.
     *
     * @todo names of the exml entities are not well choosen. A change will have
     * impact on other parts of the code, of course.
     */
    
    function genSolution($p_exercise_id, $p_number_of_answers) {
        $num_answers = explode(',', $p_number_of_answers);
        $xml = '<solution id="'.$p_exercise_id.'">';
        
        for ($j = 0; $j < count($num_answers); ++$j) {
            $xml .= '<answer id="'.$j.'">';
            $xml .= '<body>'.htmlspecialchars(getExternalParam('answer_'.$j)).'</body>';
            $xml .= '</answer>';
        }
        
        $xml .= '</solution>';
        return $xml;
    }
    
    
    
    /**
     * Generate the description af an exercise in an XML-String.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @return XML the SML-String describing the exercise in terms of its
     * name, questions, worng and correct solutions etc.
     */
    
    function getExerciseConstruct() {
        
        /*************************************************************************/
        /* Get data
        /*************************************************************************/
        
        $m_exercise_language = "de";
        $m_exercise_type     = getExternalParam("exercise_type");
        $m_exercise_question = getExternalParam("exercise_question");
        $m_exercise_name     = getExternalParam("exercise_name");
        $m_exerciseHint      = getExternalParam("exercise_hint");
        $m_exercise_comment  = getExternalParam("exercise_comment");
        
        $m_exercise_pic_url  = getExternalParam("exercise_pic_url");
        $m_provides          = getExternalParam("provides");
        $m_depends           = getExternalParam("depends");
        $m_optional_depends  = getExternalParam("optional_depends");
        
        $m_number_of_answers = getExternalParam("number_of_answers");
        $m_mc_auswertung     = getExternalParam("mc_auswertung");
        $num_answers = explode(',', $m_number_of_answers);
        
        for ($j = 0; $j < count($num_answers); ++$j) {
            $correct_array[$j] = getExternalParam("correct_".$j);
            
            for ($i = 0; $i < $num_answers[$j]; ++$i) {
                $answer_array[$j][$i]  = getExternalParam("answer_".$j."_".$i);
            }
        }
        
        
        
        /*************************************************************************/
        /* Construct XML
        /*************************************************************************/
        
        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"SingleChoice\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        $xmlop .= "<Hint>".htmlspecialchars($m_exerciseHint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_pic_url)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";
        $xmlop .= "<EvalMode>".htmlspecialchars($m_mc_auswertung)."</EvalMode>";
        
        $group = 0;
        
        for ($j = 0; $j < count($answer_array); ++$j) {
            $emtpy = TRUE;
            
            for ($i = 0; $i < count($answer_array[$j]); ++$i) {
                if ($answer_array[$j][$i] != '') {
                    $emtpy = FALSE;
                    $correct = $i == $correct_array[$j] ? '1' : '0';  // 1 indicates correct
                    
                    $xmlop .= '<Answer group="'.$group.'" Correct="'.$correct.'">'.htmlspecialchars($answer_array[$j][$i]).'</Answer>';
                }
            }
            
            if (!$emtpy) ++$group;
        }
        
        $this->g_maxPoints = $group;
        
        $xmlop .= "</TestItem>";
        
        /*************************************************************************/
        /* Return XML
        /*************************************************************************/
        
        return $xmlop;
    }
}
?>
