<?php
/*
 * yn_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    XXX
 * @copyright XXX
 * @abstract
 */
class yn_exercise extends Exercise {
    
//      var $g_numberOfAnswers;
//      var $g_ExerciseName = "Yes-No-Exercise";
//      var $g_ExerciseDescription = "DescriptionExerciseYN";
    var $g_maxPoints = 1;
    
    function  yn_exercise() {
//              $this->g_numberOfAnswers                = 1;
//              $this->g_Action                                 = getExternalParam('action');
//              $this->g_OpenObject                     = 'openobject_' 
//                                                                                      . strtolower($this->Action); 
    }
    
    
    
    /**************************************************************************/
    /*
    /* Evaluates the solution
    /*
    /**************************************************************************/    
    
    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */
    
    function evaluate($exercise,$solution) {
        
        $punkte = 0;
        
        $dom_xml = $this->getDomXML($exercise);
        $answers = $dom_xml->get_elements_by_tagname("Answer");
        
        $answer_array = array();
        $correct_array = array();
        
        //get answer + correct array
        foreach ($answers as $key=>$node) {
            $answer_array[]         = html_ready(utf8_decode($node->get_content()));
            if ($node->get_attribute("Correct") == '1')
                $correct_array[0]       = $key;
        }
        $student_array = $this->getTagsFromXML($solution, "answer");
        
        if ($student_array[0] == $correct_array[0]) $punkte = 1;
        
        $m_prozent = $punkte * 100 ;
        $m_save = 0;
        if ($m_prozent == 100 || $m_prozent == 0) {
            $m_save = 1;
        }
        
        $m_return[1] = $m_prozent;
        $m_return[2] = $m_save;
        $m_return[5] = $punkte;
        return $m_return;
    }
    
    
    
    /**************************************************************************/
    /*
    /* XML-generating routines
    /*
    /**************************************************************************/    
    
    
    
    /**
     * Generates generates an XML-String containing the solution of the
     * student.
     *
     * Gets ist values to be stored in the XML-String from the 
     * Get/Post environment.
     * 
     * @param int $exercise_id the id of the exercise the solution related to.
     * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
     * @return XML the XML-String containing the solutions of the student.
     * 
     * @todo names of the exml entities are not well choosen. A change will have
     * impact on other parts of the code, of course.
     */
    
    function genSolution($p_exercise_id, $p_number_of_answers)
    {
        $xml  = '<solution id="'.$p_exercise_id.'">';
        $xml .= '<answer id="0">';
        $xml .= '<body>'.htmlspecialchars(getExternalParam("answer_0")).'</body>';  //position!
        $xml .= '</answer>';
        $xml .= '</solution>';
        
        return $xml;
    }
    
    
    
    /**
     * Generate the description af an exercise in an XML-String.
     *
     * Gets ist values to be stored in the XML-String from the 
     * Get/Post environment.
     * 
     * @return XML the SML-String describing the exercise in terms of its
     * name, questions, worng and correct solutions etc.
     */
    
    function getExerciseConstruct() {
        
        /*************************************************************************/
        /* Get data
        /*************************************************************************/
        
        $m_exercise_language = "de";
        $m_exercise_type     = getExternalParam("exercise_type");
        $m_exercise_question = getExternalParam("exercise_question");
        $m_exercise_name     = getExternalParam("exercise_name");
        $m_exerciseHint      = getExternalParam("exercise_hint");
        $m_exercise_comment  = getExternalParam("exercise_comment");
        
        $m_exercise_pic_url  = getExternalParam("exercise_pic_url");
        $m_provides          = getExternalParam("provides");
        $m_depends           = getExternalParam("depends");
        $m_optional_depends  = getExternalParam("optional_depends");
        
        $correct_array[0] = getExternalParam("correct_0");

        $answer_array[0]  = getExternalParam("label_yes");
        $answer_array[1]  = getExternalParam("label_no");

        /*************************************************************************/
        /* Construct XML
        /*************************************************************************/
        
        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"JaNeinFrage\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        $xmlop .= "<Hint>".htmlspecialchars($m_exerciseHint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_pic_url)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";
        
        $index = $correct_array[0];
        for ($i=0;$i < count($answer_array);$i++) {
            if ($answer_array[$i]) {
                if ($i == $index) {
                    $xmlop .= '<Answer Correct="1">'.htmlspecialchars($answer_array[$i]).'</Answer>';
                }
                else {  
                    $xmlop .= '<Answer Correct="0">'.htmlspecialchars($answer_array[$i]).'</Answer>';
                }
                
            }
        }
        
        $xmlop .= "</TestItem>";
        
        /*************************************************************************/
        /* Return XML
        /*************************************************************************/
        
        return ($xmlop);
    }
}
?>
